
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Atk.Interfaces.TableCell
    ( 

-- * Exported types
    TableCell(..)                           ,
    noTableCell                             ,
    TableCellK                              ,
    toTableCell                             ,


 -- * Methods
-- ** tableCellGetColumnHeaderCells
    tableCellGetColumnHeaderCells           ,


-- ** tableCellGetColumnSpan
    tableCellGetColumnSpan                  ,


-- ** tableCellGetPosition
    tableCellGetPosition                    ,


-- ** tableCellGetRowColumnSpan
    tableCellGetRowColumnSpan               ,


-- ** tableCellGetRowHeaderCells
    tableCellGetRowHeaderCells              ,


-- ** tableCellGetRowSpan
    tableCellGetRowSpan                     ,


-- ** tableCellGetTable
    tableCellGetTable                       ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Atk.Types
import GI.Atk.Callbacks
import qualified GI.GObject as GObject

-- interface TableCell 

newtype TableCell = TableCell (ForeignPtr TableCell)
noTableCell :: Maybe TableCell
noTableCell = Nothing

type instance AttributeList TableCell = TableCellAttributeList
type TableCellAttributeList = ('[ '("accessible-component-layer", ObjectAccessibleComponentLayerPropertyInfo), '("accessible-component-mdi-zorder", ObjectAccessibleComponentMdiZorderPropertyInfo), '("accessible-description", ObjectAccessibleDescriptionPropertyInfo), '("accessible-hypertext-nlinks", ObjectAccessibleHypertextNlinksPropertyInfo), '("accessible-name", ObjectAccessibleNamePropertyInfo), '("accessible-parent", ObjectAccessibleParentPropertyInfo), '("accessible-role", ObjectAccessibleRolePropertyInfo), '("accessible-table-caption", ObjectAccessibleTableCaptionPropertyInfo), '("accessible-table-caption-object", ObjectAccessibleTableCaptionObjectPropertyInfo), '("accessible-table-column-description", ObjectAccessibleTableColumnDescriptionPropertyInfo), '("accessible-table-column-header", ObjectAccessibleTableColumnHeaderPropertyInfo), '("accessible-table-row-description", ObjectAccessibleTableRowDescriptionPropertyInfo), '("accessible-table-row-header", ObjectAccessibleTableRowHeaderPropertyInfo), '("accessible-table-summary", ObjectAccessibleTableSummaryPropertyInfo), '("accessible-value", ObjectAccessibleValuePropertyInfo)] :: [(Symbol, *)])

type instance SignalList TableCell = TableCellSignalList
type TableCellSignalList = ('[ '("active-descendant-changed", ObjectActiveDescendantChangedSignalInfo), '("children-changed", ObjectChildrenChangedSignalInfo), '("focus-event", ObjectFocusEventSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("property-change", ObjectPropertyChangeSignalInfo), '("state-change", ObjectStateChangeSignalInfo), '("visible-data-changed", ObjectVisibleDataChangedSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

foreign import ccall "atk_table_cell_get_type"
    c_atk_table_cell_get_type :: IO GType

type instance ParentTypes TableCell = TableCellParentTypes
type TableCellParentTypes = '[Object, GObject.Object]

instance GObject TableCell where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_atk_table_cell_get_type
    

class GObject o => TableCellK o
instance (GObject o, IsDescendantOf TableCell o) => TableCellK o

toTableCell :: TableCellK o => o -> IO TableCell
toTableCell = unsafeCastTo TableCell

-- method TableCell::get_column_header_cells
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TPtrArray (TInterface "Atk" "Object")
-- throws : False
-- Skip return : False

foreign import ccall "atk_table_cell_get_column_header_cells" atk_table_cell_get_column_header_cells :: 
    Ptr TableCell ->                        -- _obj : TInterface "Atk" "TableCell"
    IO (Ptr (GPtrArray (Ptr Object)))


tableCellGetColumnHeaderCells ::
    (MonadIO m, TableCellK a) =>
    a ->                                    -- _obj
    m [Object]
tableCellGetColumnHeaderCells _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- atk_table_cell_get_column_header_cells _obj'
    checkUnexpectedReturnNULL "atk_table_cell_get_column_header_cells" result
    result' <- unpackGPtrArray result
    result'' <- mapM (wrapObject Object) result'
    unrefPtrArray result
    touchManagedPtr _obj
    return result''

-- method TableCell::get_column_span
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt32
-- throws : False
-- Skip return : False

foreign import ccall "atk_table_cell_get_column_span" atk_table_cell_get_column_span :: 
    Ptr TableCell ->                        -- _obj : TInterface "Atk" "TableCell"
    IO Int32


tableCellGetColumnSpan ::
    (MonadIO m, TableCellK a) =>
    a ->                                    -- _obj
    m Int32
tableCellGetColumnSpan _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- atk_table_cell_get_column_span _obj'
    touchManagedPtr _obj
    return result

-- method TableCell::get_position
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "row", argType = TBasicType TInt32, direction = DirectionOut, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferEverything},Arg {argName = "column", argType = TBasicType TInt32, direction = DirectionOut, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferEverything}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "atk_table_cell_get_position" atk_table_cell_get_position :: 
    Ptr TableCell ->                        -- _obj : TInterface "Atk" "TableCell"
    Ptr Int32 ->                            -- row : TBasicType TInt32
    Ptr Int32 ->                            -- column : TBasicType TInt32
    IO CInt


tableCellGetPosition ::
    (MonadIO m, TableCellK a) =>
    a ->                                    -- _obj
    m (Bool,Int32,Int32)
tableCellGetPosition _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    row <- allocMem :: IO (Ptr Int32)
    column <- allocMem :: IO (Ptr Int32)
    result <- atk_table_cell_get_position _obj' row column
    let result' = (/= 0) result
    row' <- peek row
    column' <- peek column
    touchManagedPtr _obj
    freeMem row
    freeMem column
    return (result', row', column')

-- method TableCell::get_row_column_span
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "row", argType = TBasicType TInt32, direction = DirectionOut, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferEverything},Arg {argName = "column", argType = TBasicType TInt32, direction = DirectionOut, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferEverything},Arg {argName = "row_span", argType = TBasicType TInt32, direction = DirectionOut, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferEverything},Arg {argName = "column_span", argType = TBasicType TInt32, direction = DirectionOut, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferEverything}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "atk_table_cell_get_row_column_span" atk_table_cell_get_row_column_span :: 
    Ptr TableCell ->                        -- _obj : TInterface "Atk" "TableCell"
    Ptr Int32 ->                            -- row : TBasicType TInt32
    Ptr Int32 ->                            -- column : TBasicType TInt32
    Ptr Int32 ->                            -- row_span : TBasicType TInt32
    Ptr Int32 ->                            -- column_span : TBasicType TInt32
    IO CInt


tableCellGetRowColumnSpan ::
    (MonadIO m, TableCellK a) =>
    a ->                                    -- _obj
    m (Bool,Int32,Int32,Int32,Int32)
tableCellGetRowColumnSpan _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    row <- allocMem :: IO (Ptr Int32)
    column <- allocMem :: IO (Ptr Int32)
    row_span <- allocMem :: IO (Ptr Int32)
    column_span <- allocMem :: IO (Ptr Int32)
    result <- atk_table_cell_get_row_column_span _obj' row column row_span column_span
    let result' = (/= 0) result
    row' <- peek row
    column' <- peek column
    row_span' <- peek row_span
    column_span' <- peek column_span
    touchManagedPtr _obj
    freeMem row
    freeMem column
    freeMem row_span
    freeMem column_span
    return (result', row', column', row_span', column_span')

-- method TableCell::get_row_header_cells
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TPtrArray (TInterface "Atk" "Object")
-- throws : False
-- Skip return : False

foreign import ccall "atk_table_cell_get_row_header_cells" atk_table_cell_get_row_header_cells :: 
    Ptr TableCell ->                        -- _obj : TInterface "Atk" "TableCell"
    IO (Ptr (GPtrArray (Ptr Object)))


tableCellGetRowHeaderCells ::
    (MonadIO m, TableCellK a) =>
    a ->                                    -- _obj
    m [Object]
tableCellGetRowHeaderCells _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- atk_table_cell_get_row_header_cells _obj'
    checkUnexpectedReturnNULL "atk_table_cell_get_row_header_cells" result
    result' <- unpackGPtrArray result
    result'' <- mapM (wrapObject Object) result'
    unrefPtrArray result
    touchManagedPtr _obj
    return result''

-- method TableCell::get_row_span
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt32
-- throws : False
-- Skip return : False

foreign import ccall "atk_table_cell_get_row_span" atk_table_cell_get_row_span :: 
    Ptr TableCell ->                        -- _obj : TInterface "Atk" "TableCell"
    IO Int32


tableCellGetRowSpan ::
    (MonadIO m, TableCellK a) =>
    a ->                                    -- _obj
    m Int32
tableCellGetRowSpan _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- atk_table_cell_get_row_span _obj'
    touchManagedPtr _obj
    return result

-- method TableCell::get_table
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Atk" "TableCell", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Atk" "Object"
-- throws : False
-- Skip return : False

foreign import ccall "atk_table_cell_get_table" atk_table_cell_get_table :: 
    Ptr TableCell ->                        -- _obj : TInterface "Atk" "TableCell"
    IO (Ptr Object)


tableCellGetTable ::
    (MonadIO m, TableCellK a) =>
    a ->                                    -- _obj
    m Object
tableCellGetTable _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- atk_table_cell_get_table _obj'
    checkUnexpectedReturnNULL "atk_table_cell_get_table" result
    result' <- (wrapObject Object) result
    touchManagedPtr _obj
    return result'


