
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Atk.Objects.NoOpObject
    ( 

-- * Exported types
    NoOpObject(..)                          ,
    NoOpObjectK                             ,
    toNoOpObject                            ,
    noNoOpObject                            ,


 -- * Methods
-- ** noOpObjectNew
    noOpObjectNew                           ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Atk.Types
import GI.Atk.Callbacks
import qualified GI.GObject as GObject

newtype NoOpObject = NoOpObject (ForeignPtr NoOpObject)
foreign import ccall "atk_no_op_object_get_type"
    c_atk_no_op_object_get_type :: IO GType

type instance ParentTypes NoOpObject = NoOpObjectParentTypes
type NoOpObjectParentTypes = '[Object, GObject.Object, Action, Component, Document, EditableText, Hypertext, Image, Selection, Table, TableCell, Text, Value, Window]

instance GObject NoOpObject where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_atk_no_op_object_get_type
    

class GObject o => NoOpObjectK o
instance (GObject o, IsDescendantOf NoOpObject o) => NoOpObjectK o

toNoOpObject :: NoOpObjectK o => o -> IO NoOpObject
toNoOpObject = unsafeCastTo NoOpObject

noNoOpObject :: Maybe NoOpObject
noNoOpObject = Nothing

type instance AttributeList NoOpObject = NoOpObjectAttributeList
type NoOpObjectAttributeList = ('[ '("accessible-component-layer", ObjectAccessibleComponentLayerPropertyInfo), '("accessible-component-mdi-zorder", ObjectAccessibleComponentMdiZorderPropertyInfo), '("accessible-description", ObjectAccessibleDescriptionPropertyInfo), '("accessible-hypertext-nlinks", ObjectAccessibleHypertextNlinksPropertyInfo), '("accessible-name", ObjectAccessibleNamePropertyInfo), '("accessible-parent", ObjectAccessibleParentPropertyInfo), '("accessible-role", ObjectAccessibleRolePropertyInfo), '("accessible-table-caption", ObjectAccessibleTableCaptionPropertyInfo), '("accessible-table-caption-object", ObjectAccessibleTableCaptionObjectPropertyInfo), '("accessible-table-column-description", ObjectAccessibleTableColumnDescriptionPropertyInfo), '("accessible-table-column-header", ObjectAccessibleTableColumnHeaderPropertyInfo), '("accessible-table-row-description", ObjectAccessibleTableRowDescriptionPropertyInfo), '("accessible-table-row-header", ObjectAccessibleTableRowHeaderPropertyInfo), '("accessible-table-summary", ObjectAccessibleTableSummaryPropertyInfo), '("accessible-value", ObjectAccessibleValuePropertyInfo)] :: [(Symbol, *)])

type instance SignalList NoOpObject = NoOpObjectSignalList
type NoOpObjectSignalList = ('[ '("activate", WindowActivateSignalInfo), '("active-descendant-changed", ObjectActiveDescendantChangedSignalInfo), '("bounds-changed", ComponentBoundsChangedSignalInfo), '("children-changed", ObjectChildrenChangedSignalInfo), '("column-deleted", TableColumnDeletedSignalInfo), '("column-inserted", TableColumnInsertedSignalInfo), '("column-reordered", TableColumnReorderedSignalInfo), '("create", WindowCreateSignalInfo), '("deactivate", WindowDeactivateSignalInfo), '("destroy", WindowDestroySignalInfo), '("focus-event", ObjectFocusEventSignalInfo), '("link-selected", HypertextLinkSelectedSignalInfo), '("load-complete", DocumentLoadCompleteSignalInfo), '("load-stopped", DocumentLoadStoppedSignalInfo), '("maximize", WindowMaximizeSignalInfo), '("minimize", WindowMinimizeSignalInfo), '("model-changed", TableModelChangedSignalInfo), '("move", WindowMoveSignalInfo), '("notify", GObject.ObjectNotifySignalInfo), '("page-changed", DocumentPageChangedSignalInfo), '("property-change", ObjectPropertyChangeSignalInfo), '("reload", DocumentReloadSignalInfo), '("resize", WindowResizeSignalInfo), '("restore", WindowRestoreSignalInfo), '("row-deleted", TableRowDeletedSignalInfo), '("row-inserted", TableRowInsertedSignalInfo), '("row-reordered", TableRowReorderedSignalInfo), '("selection-changed", SelectionSelectionChangedSignalInfo), '("state-change", ObjectStateChangeSignalInfo), '("text-attributes-changed", TextTextAttributesChangedSignalInfo), '("text-caret-moved", TextTextCaretMovedSignalInfo), '("text-changed", TextTextChangedSignalInfo), '("text-insert", TextTextInsertSignalInfo), '("text-remove", TextTextRemoveSignalInfo), '("text-selection-changed", TextTextSelectionChangedSignalInfo), '("value-changed", ValueValueChangedSignalInfo), '("visible-data-changed", ObjectVisibleDataChangedSignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method NoOpObject::new
-- method type : Constructor
-- Args : [Arg {argName = "obj", argType = TInterface "GObject" "Object", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "obj", argType = TInterface "GObject" "Object", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Atk" "NoOpObject"
-- throws : False
-- Skip return : False

foreign import ccall "atk_no_op_object_new" atk_no_op_object_new :: 
    Ptr GObject.Object ->                   -- obj : TInterface "GObject" "Object"
    IO (Ptr NoOpObject)


noOpObjectNew ::
    (MonadIO m, GObject.ObjectK a) =>
    a ->                                    -- obj
    m NoOpObject
noOpObjectNew obj = liftIO $ do
    let obj' = unsafeManagedPtrCastPtr obj
    result <- atk_no_op_object_new obj'
    checkUnexpectedReturnNULL "atk_no_op_object_new" result
    result' <- (wrapObject NoOpObject) result
    touchManagedPtr obj
    return result'


